var EXPORTED_SYMBOLS = ["KclHttpObserver","KclInfo"];


var KclInfo = {
    gMasterShip: [],
    gMemberShip: [],
    gMemberFleet: [],
    gQuestList: [],
    gMasterQuestList: [],
    gMemberBasic: [],
    gMemberItem: [],
    gMasterItem: [],
    gMemberNDock: [],
    gMemberKDock: [],
    gMapRequest: [],
    gBattle: [],
    gBattleResult: [],
    gMapInfo: [],
    gMapCell: [],
    gMaterial: [],
    gapi_start2: [],
    gLastMsg: []

};
var hw_prefs;
var hw_Branch;
var callback = new Array();
const Cc = Components.classes;
const Ci = Components.interfaces;

function debugprint(str){
    let aConsoleService = Cc["@mozilla.org/consoleservice;1"].getService(Ci.nsIConsoleService);
    aConsoleService.logStringMessage(str);
}

function CCIN(cName, ifaceName) {
    return Cc[cName].createInstance(Ci[ifaceName]);
}

function TracingListener() {
    this.originalListener = null;
}

TracingListener.prototype =
{
    onDataAvailable: function(request, context, inputStream, offset, count) {
        let binaryInputStream = CCIN("@mozilla.org/binaryinputstream;1","nsIBinaryInputStream");
        let storageStream = CCIN("@mozilla.org/storagestream;1", "nsIStorageStream");
        let binaryOutputStream = CCIN("@mozilla.org/binaryoutputstream;1","nsIBinaryOutputStream");

        binaryInputStream.setInputStream(inputStream);
        storageStream.init(8192, count, null);
        binaryOutputStream.setOutputStream(storageStream.getOutputStream(0));

        let data = binaryInputStream.readBytes(count);
        this.receivedData.push(data);
        binaryOutputStream.writeBytes(data, count);

        this.originalListener.onDataAvailable(request, context,storageStream.newInputStream(0), offset, count);
    },

    onStartRequest: function(request, context) {
        this.originalListener.onStartRequest(request, context);
        this.receivedData = new Array();
    },

    onStopRequest: function(request, context, statusCode) {
        this.originalListener.onStopRequest(request, context, statusCode);

        let httpChannel= request.QueryInterface(Ci.nsIHttpChannel);
        let r="";
        if(httpChannel.requestMethod == "POST"){
            let uploadChannel=httpChannel.QueryInterface(Ci.nsIUploadChannel);
            let SeekableChannel = uploadChannel.uploadStream;
            SeekableChannel.QueryInterface(Ci.nsISeekableStream).seek(0, 0);  
            var stream = Cc["@mozilla.org/binaryinputstream;1"].createInstance(Ci.nsIBinaryInputStream);  
            stream.setInputStream(SeekableChannel);
            let postBytes = stream.readByteArray(stream.available());
            let poststr = String.fromCharCode.apply(null, postBytes);
            this.postData=poststr;
            r=poststr;
        }
        let s = this.receivedData.join("");
        for( var i in  callback ){
            let fnc = callback[i];
            if( typeof fnc=="function" ){
            fnc( request.name, s , r , httpChannel.responseStatus);
            }
        }
    },

    QueryInterface: function (aIID) {
        if (aIID.equals(Ci.nsIStreamListener) || aIID.equals(Ci.nsISupports)) {
            return this;
        }
        throw Components.results.NS_NOINTERFACE;
    }
};


var KclHttpObserver =
{
    HookCounter: 0,

    observe: function(aSubject, aTopic, aData){
        if (aTopic == "http-on-examine-response"){
            var httpChannel = aSubject.QueryInterface(Ci.nsIHttpChannel);
            if( httpChannel.URI.spec.match(/^http.*\/kcsapi\//) ){
                var newListener = new TracingListener();
                aSubject.QueryInterface(Ci.nsITraceableChannel);
                newListener.originalListener = aSubject.setNewListener(newListener);
            }else if( httpChannel.URI.spec.match(/^http.*\/kcs\//) ){
                var newListener = new TracingListener();
                aSubject.QueryInterface(Ci.nsITraceableChannel);
                newListener.originalListener = aSubject.setNewListener(newListener);
            }
        }else if (aTopic == "http-on-modify-request"){
        }
    },

    QueryInterface : function (aIID) {
        if (aIID.equals(Ci.nsIObserver) || aIID.equals(Ci.nsISupports)){
            return this;
        }
        throw Components.results.NS_NOINTERFACE;
    },

    addCallback: function(fname){
        callback.push( fname );
        debugprint( 'start kclinsp/add callback='+callback.length );
    },

    removeCallback: function(fname){
        for( var kptr in callback ){
            if( callback[kptr]==fname ){
                callback.splice(kptr,1);
                debugprint( 'stop kclinsp/remove callback='+callback.length );
            }
        }
    },

    init: function(){
        if( this.HookCounter==0 ){
            this.observerService = Cc["@mozilla.org/observer-service;1"]
            .getService(Ci.nsIObserverService);
            this.observerService.addObserver(this, "http-on-examine-response", false);
            this.observerService.addObserver(this, "http-on-modify-request", false);
        }
        this.HookCounter++;

        hw_prefs=Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService);
        hw_Branch=hw_prefs.getBranch("extensions.kclinsp.");

    },

    destroy: function(){
        this.HookCounter--;
        if( this.HookCounter<=0 ){
            this.observerService.removeObserver(this, "http-on-examine-response");
            this.observerService.removeObserver(this, "http-on-modify-request");
            this.HookCounter = 0;
        }
    }

};

